;****************************************************************************
;* Programator: David Hankovec   DH-servis,vyvoj a vyroba elektroniky       *                   
;* Program    :	DCF-77 casovy decoder                                   	    *
;* Datum      : 01-12-2002 *
;* Versie 	  : V1.1                            kompletni s logem a eeprom               *
;****************************************************************************

$MOD52
$TITLE(BYTE SIGNED MULTIPLY)
$PAGEWIDTH(132)
$DEBUG
$OBJECT
$NOPAGING


org 00
AJMP start			;cold START

org 0bH			;INT od TIMERu 0
ljmp intt0

;****************************************************************************
;              Deklarace bitovych promennych                                *
;****************************************************************************
dcf77_puls      bit P3.2 ;vstup telegramu DCF
synchronni	bit P3.1	;DCF je synchronni / vystup na LED
asynchronni	bit P3.0	;DCF neni synchronni / vystup na LED
vst_TL		bit P3.3	;vstup tlacitek

;Signaly serioveho interface EEPROM
SClk            equ     p3.6 ; jako vystup z 8051 / u pameti pin c.2
SDI             equ     p3.5 ; jako vystup z 8051 / u pameti pin c.3
SDO             equ     p3.4 ; jako vstup do 8051 / u pameti pin c.4
EESel           equ     p3.7 ; jako vystup z 8051, signal CS / u pameti pin c.1
					

bseg at 30

DATA_BIT:         DBIT  1     ;
DCF_new:      	DBIT  1     ;signalizace, ze bit na vstupu z DCF je zmenen
SYNCHRON:         DBIT  1     ;synchronizace signalem DCF
ASYNC:            DBIT  1     ;0= DCF77-je zasynchronizovano
                              ;1= DCF77-neni synchronni
;----------------------------------------------------------------------------
ok_data:        	DBIT  1     ;priznak o.k. nactenych dat z DCF do RAM
RES_ANT:          DBIT  1     ;priznak rezervni anteny
Z_cas:          	DBIT  1     ;Zimni / letni cas
PARITY_ERROR:     DBIT  1     ;chyba parity
FULL_SECOND:      DBIT  1     ;1= dokoncena sekunda - cpl bitu po sekunde
FULL_MINUTE:      DBIT  1     ;1= dokoncena minuta (clr in hoofdpr)

tecka:		dbit 1		;priznak pro rozsviceni tecky u data
stisknuto0:		dbit 1		;priznak ze tlacitko bylo stisknuto
stisknuto1:		dbit 1
stisknuto2:		dbit 1
stisknuto3:		dbit 1
edit0:		dbit 1		;priznak ze jsem v editaci
edit1:		dbit 1		;priznak ze jsem v editaci
edit2:		dbit 1		;priznak ze jsem v editaci
edit3:		dbit 1		;priznak ze jsem v editaci
stisknuto_UP:	dbit 1
stisknuto_DOWN:	dbit 1
po_resetu:		dbit 1
WaitingBusy:      dbit 1    ;bit. promenna signalizujici nedokonceny zapis do EEPROM
no_eeprom:		dbit 1    ;pokud je nastaven, nectou se data z eeprom,ale nactou se implicitni
;****************************************************************************
;obsazeni portu PORT 3 jsou katody / 8 vyvodu
;PORT 2 a cast portu 0 jsou 

anoda_0_dis_0	bit P2.3
anoda_1_dis_0	bit P2.2
anoda_2_dis_0	bit P2.1
anoda_3_dis_0	bit P2.0

anoda_0_dis_1	bit P2.7
anoda_1_dis_1	bit P2.6
anoda_2_dis_1	bit P2.5
anoda_3_dis_1	bit P2.4

anoda_0_dis_2	bit P0.7
anoda_1_dis_2	bit P0.6
anoda_2_dis_2	bit P0.5
anoda_3_dis_2	bit P0.4

anoda_0_dis_3	bit P0.3
anoda_1_dis_3	bit P0.2
anoda_2_dis_3	bit P0.1
anoda_3_dis_3	bit P0.0

;**********************************************************************************
;Predvolba preteceni casovace po 20msec
;Predvolba pro casovac (65535 - 20008) pro 12 MHz krystal

predvolba         equ  0FFFFH - 12000 * 5/3 + 7 + 1  ; vypocet
                              ;12000 pri 12 MHz (delka )
			      ;Start hodnota Timer (= 20msec-Puls)

;****************************************************************************
;Mereni delky(cteni) DCF-77 pulsu: princip = 20 msec * konstanta ,20msec. je preteceni casovace
;rozmezi SS_MIN = 2 * 20msec=40 msec   ////     SS_MAX = 6 * 20msec=120msec
;nastaveni meznich casu trvani pulsu na 1 DCF puls:
 
SS_MIN          equ   02      ;minimalni delka impulsu pro impuls "0" - 2x20=40msec
SS_MAX          equ   06      ;maximalni delka impulsu pro impuls "0" - 6x20=120msec 
SL_MIN          equ   07      ;minimalni delka impulsu pro impuls "1" - 7x20=140msec 
SL_MAX          equ   14      ;minimalni delka impulsu pro impuls "1" - 14x20=280msec

;nastaveni meznich casu trvani mezery na 1 DCF puls:
;princip = 1000msec (50*20msec) - pausovy DCF-77 puls = vysl.

PS_MIN          equ   50 - SL_MAX   ;minimalni delka mezery pro impuls impuls "1" jako vyse,cas je 720msec
PS_MAX          equ   50 - SL_MIN   ;maximalni delka mezery pro impuls impuls "1"	860msec
PL_MIN          equ   50 - SS_MAX   ;minimalni delka mezery pro impuls impuls "0"	880msec	
PL_MAX          equ   50 - SS_MIN   ;minimalni delka mezery pro impuls impuls "0"	960msec

;testovani mezery po 59'sec,zde chybi impuls a mezera trva 2 sekundy
;princip = 2000msec (100*20msec) - nulovy DCF-77 puls

PSD_MIN         equ  100 - SL_MAX   ;minimalni delka mezery pro dvojitou pausu pro posledni puls "1" 1720msec
PSD_MAX         equ  100 - SL_MIN   ;maximalni delka mezery pro dvojitou pausu pro posledni puls "1" 1860msec
PLD_MIN         equ  100 - SS_MAX   ;minimalni delka mezery pro dvojitou pausu pro posledni puls "0" 1880msec	 
PLD_MAX         equ  100 - SS_MIN   ;maximalni delka mezery pro dvojitou pausu pro posledni puls "0" 1960msec
;-----------------toto jsou konstanty,podle cisla se pozna pozadovana funkce k zobrazeni----------------------
fce_hodiny			equ 0H
fce_datum			equ 01H
fce_rok			equ 02H
fce_DvT			equ 03H

;****************************************************************************
;                           Definice promennych
;****************************************************************************
T0valuH         equ     high predvolba ;predvolba timer interrupt high
T0valuL         equ     low  predvolba ;predvolba timer interrupt low

displej		equ 30H	;zde je ulozeno cislo displeje (21 = prvni az 23 = treti)
typ_fce_dis0	equ 31H	;zde je ulozen typ zobrazovane funkce dle displeje
typ_fce_dis1	equ 32H	;fce 0=hodiny, 1=datum, 2=rok, 3=DvT
typ_fce_dis2	equ 33H
typ_fce_dis3	equ 34H
anoda			equ 35H	;cislo anody

dis_hi		equ 37H	;byty do kterych se nactou data,vymaskuji a poslou na displej
dis_lo		equ 38H
incr_hod0		equ 39H	;zde je cislo, o kolik se hodiny posunou / v hexa
incr_hod1		equ 3AH
incr_hod2		equ 3BH
incr_hod3		equ 3CH
doba_tlacitka0	equ 3DH	;po prekroceni casu vstup do editace
doba_tlacitka1	equ 3EH
doba_tlacitka2	equ 3FH
doba_tlacitka3	equ 40H
;****************pro prevod z hexa do bcd*********************
vaha			equ	41H
vstup			equ	42H		;definovano - nizsi byte(prevadene byty)
vysl			equ	43H
pocpos		equ	44H	;pocet posuvu
tmp			equ	45H
;*************************************************************
BLOCK_PTR       equ   46h            ;ukazatel (pointer) pro pohyb v Data-Bloku
DCF_sekundy     equ   47h            ;pocitadlo sekund z DCF
COUNTER         equ   48h            ;inkrementovn po 20msec v preruseni od casovace
                                     ;nacita delku DCF-pulsu            
;***************************************************************************
;                     Interni Ram lokace pro real-time-hodiny promenne v BCD
;***************************************************************************
TIKKER         equ   49h            ;pocitadlo preteceni casovace po 20msec. ,toto pocitadlo pretece po 50x cili 1sec.
sekundy        equ   4ah            ;platny cas  - sekundy (bud v synchro s DCF nebo samostante)
minuty         equ   4bh            ;platny cas  - minuty
hodiny         equ   4ch            ;platny cas  - hodiny
den            equ   4dh            ;platny cas  - den
mesic          equ   4eh            ;platny cas  - mesic
rok            equ   4fh            ;platny cas  - rok
d_v_t          equ   50h            ;platny cas  - den v tydnu
Address	   equ   51H		;;aktualne zap./ctena adresa EEPROM 		

;****************************************************************************
;            Data blok pro rozdelen kompletniho telegramu DCF na jednotlive casti
;****************************************************************************
                      dseg at 51h
DATA_BLOCK:       DS 2            ; zde ulozena DCF-77 data jako nahr.antena,zimni cas<
    DB_MIN:       DS 1            ; minuty informace (+ Parity-Bit P1)   <
    DB_HR:        DS 1            ; hodiny informace    (+ Parity-Bit P2)   <
    DB_DAY:       DS 1            ; den informatie                <
    DB_MON:       DS 1            ; den v tydnu/mesic informatie              <
    DB_YR:        DS 1            ; rok informace               <<<<<<<<<

;----------------------------------------------------------------------------
;****************************************************************************
;               H L A V N I   S M Y C K A
;****************************************************************************
                        cseg at 50h
;----------------------------------------------------------------------------
start:
;-------------------------------> inicializace
	SETB vst_TL
	CLR no_eeprom		;shod priznak
	LCALL zhasni
	LCALL logo
	LCALL zhasni

	LCALL	EEINI			;inicializuj EEPROM
	LCALL cteni			;cti data z eeprom

	JNB no_eeprom,start_1	;pokud je z loga pozadavek implicitnich dat, nenacitej eeprom
	MOV typ_fce_dis0,#1  	;tato data se nactou pokud se nectou data z eeprom  
	MOV typ_fce_dis1,#0 
	MOV typ_fce_dis2,#2 
	MOV typ_fce_dis3,#3 

	MOV incr_hod0,#0	
	MOV incr_hod1,#0	
	MOV incr_hod2,#0	
	MOV incr_hod3,#0	

start_1:MOV SP,#5AH         ;nastaveni zasobniku na 5Ah
                              ;cas neni nastaven
      SETB RS0  		;druha registrova banka
	CALL  DCF_INIT          ;inicializace DCF-scan + preruseni timer

      MOV   rok,#0AAH          ;Obsazeni promennych real time clock po startu 
      MOV   mesic,#0AAH
      MOV   den,#0AAH
      MOV   hodiny,#0AAH
      MOV   minuty,#0AAH
      MOV   sekundy,#0AAH
	MOV   d_v_t,#08       
	
	CLR edit0
	CLR edit1
	CLR edit2
	CLR edit3

	CLR stisknuto0
	CLR stisknuto1
	CLR stisknuto2
	CLR stisknuto3

	MOV doba_tlacitka0,#50H
	MOV doba_tlacitka1,#50H
	MOV doba_tlacitka2,#50H
	MOV doba_tlacitka3,#50H
	CLR asynchronni		;rozsvit rudou LED

	SETB po_resetu		;nastavi se priznak a dokud neni vynulovan,zobrazuji se pomlcky.Nuluje se po prvnim
					;uspesnem nacteni casu z DCF
zac:	MOV anoda,#0H		;pocatecni anoda
	MOV displej,#typ_fce_dis0		;prvni displej
opak:	MOV R0,displej		;do Acc hodnotu typu zobrazovane funkce podle displeje
	MOV A,@R0			;v Acc je pozadovana funkce na displej pro aktivni displej
	LCALL obsazeni_disp
	LCALL maskuj		;data vymaskovana,poslana na port i s desetinnou teckou
	LCALL anody			;sepnuti spravne anody dle displeje,po vykonani cislo sviti		

; disp status bity
status: mov     c,async	
      cpl c
	mov     asynchronni,c
	mov c,synchron    
	cpl c
	mov synchronni,c

	
	
	INC displej			;presun na dalsi displej
	MOV A,displej
	CJNE A,#typ_fce_dis3+1,cekej		;pokud neni posledni displej, proved vypsani cifry na stejnou anodu dalsiho displeje
	LCALL cekej_10
	MOV displej,#typ_fce_dis0		;prvni displej
	INC anoda			;zvys anodu
	MOV A,anoda			;testuj anodu
	CJNE A,#4,opak
	SJMP zac			;posledni anoda,posledni displej, navrat na zacatek

cekej:	MOV r3,#0F0H
cekej_01:	MOV r4,#01H
		DJNZ R4,$
		DJNZ R3,cekej_01
sjmp opak


cekej_10:	MOV r3,#0D0H
cekej_11:	MOV r4,#01H
		DJNZ R4,$
		DJNZ R3,cekej_11
RET

;----------------------------------------------------------------------------------
;***********************KOMUNIKACE S EEPROM************************************

; s jednotlivymi bity bran se pracuje bitove, takze je mozno libovolne 
; predefinovat na jine vstupy

; Na pocatku se musi volat podprogram EEINI pro inicializaci

; Pro cteni  lze volat podprogram           READBYTE
; adresa je v promenne 'Address', data jsou v A / akumulatoru

; Pro zapis do pameti se nejprve povoli zapis (funkce  EWEN)
; Pro vlastni zapis dat do EEPROM se  vola  podprog. WRITEBYTE
; adresa je v promenne Addres, data v registru B
; 
; Po ukonceni zapisu je doporuceno pamet zpet "zamknout" funkci EWDS,
; pro ochranu dat

; !!!!!!!!!!!!!!!!!!!!!!!!!1
; pozor vstup pameti (pin) ORG se musi pripojit na "0" pro volbu prace v modu
; 128 * 8 bitu
;adresy pro odpovidajici data
;typ_fce_dis0 = adr. 01 v EEPROM
;typ_fce_dis1 = adr. 02 v EEPROM
;typ_fce_dis2 = adr. 03 v EEPROM
;typ_fce_dis3 = adr. 04 v EEPROM

;incr_hod0 = adr. 05 v EEPROM
;incr_hod1 = adr. 06 v EEPROM
;incr_hod2 = adr. 07 v EEPROM
;incr_hod3 = adr. 08 v EEPROM
;zapis do jednotlivych	adres je volan po ukonceni editace. Zaroven se uklada aktualni nastaveni displeje(kde je co zobrazeno)



zapis:
	LCALL ewen			;povol pristup do EEPROM
	MOV address,#01H
	MOV B,typ_fce_dis0
	LCALL writebyte
	
	MOV address,#02H
	MOV B,typ_fce_dis1
	LCALL writebyte

	MOV address,#03H
	MOV B,typ_fce_dis2
	LCALL writebyte

	MOV address,#04H
	MOV B,typ_fce_dis3
	LCALL writebyte

	MOV address,#05H
	MOV B,incr_hod0
	lcall writebyte
	
	MOV address,#06H
	MOV B,incr_hod1
	lcall writebyte

	MOV address,#07H
	MOV B,incr_hod2
	lcall writebyte

	MOV address,#08H
	MOV B,incr_hod3
	lcall writebyte
	LCALL	EWDS			;zakaz zapis do EEPROM
RET
;-----------------------Nacteni dat z EEPROM po resetu----------------
cteni:MOV Address,#01H
	LCALL readbyte
	MOV typ_fce_dis0,A

	MOV Address,#02H
	LCALL readbyte
	MOV typ_fce_dis1,A

	MOV Address,#03H
	LCALL readbyte
	MOV typ_fce_dis2,A

	MOV Address,#04H
	LCALL readbyte
	MOV typ_fce_dis3,A

	MOV Address,#05H
	LCALL readbyte
	MOV incr_hod0,A

	MOV Address,#06H
	LCALL readbyte
	MOV incr_hod1,A

	MOV Address,#07H
	LCALL readbyte
	MOV incr_hod2,A

	MOV Address,#08H
	LCALL readbyte
	MOV incr_hod3,A

RET
;-------------------------------------------------------------------------


;*****************************************************************************
;		Rutiny pro seriovou komunikaci s EEPROM
;*****************************************************************************


;*****************************************************************************
;Predpoklada SClk=0
;V promenne Address je ulozena adresa, ze ktere se ma cist
;Nactene slovo vrati v ACC

ReadByte: 
	call	CHeckReady	;kontrola dokonceni predchoziho zapisu
	call	StartSeq	;Vybere pamet a da start bit,SDI necha v 1
				;generace kodu prikazu READ 10b
	call	ClockPulse	;vyuziva SDI v 1 ze StartSeq
	clr	SDI
	call	ClockPulse
	call	GenAdr		;vysle adresu z promenne Address,
	clr	SDI		;vynuluj SDI

				;v tomto miste je na SDO dummy 0
	mov	r0,#8		;pocet ctenych bitu

ctibyte: 
	call	ClockPulse	;vycteni dalsiho bitu
	mov	C,SDO		;SDO do Carry
	rlc	a
	djnz	r0,ctibyte

	clr	EESel		;Deaktivace vyberu EEPROM
	call	ClockPulse
	ret

;*****************************************************************************
;Provede zapis bytu v B na adresu v ADDRESS
WriteByte: 
	call	CHeckReady	;kontrola dokonceni predchoziho zapisu
				;vynuluje EESel
	call	StartSeq	;Vybere pamet a da start bit,SDI necha v 1
				;generace kodu prikazu WRITE 01b
	clr	SDI
	call	ClockPulse	;vyuziva SDI v 1 ze StartSeq
	setb	SDI
	call	ClockPulse
	call	GenAdr		;vysle a inkrementuje adresu z promenne Address

	mov	a,b		;vysilany byte do ACC
	mov	r0,#8		;pocet bitu do r0

wrt:	rlc	a		;dalsi bit do Carry
	mov	SDI,C		;a zkopirovat na SDI
	call	ClockPulse	;a generuj hodinovy pulz
	djnz	r0,wrt

	clr	SDI		;vynulujem SDI
	clr	EESel		;zacni zapis
	call	ClockPulse
	setb	EESel		;spust kontrolu Ready/Busy
	call	ClockPulse
	setb	WaitingBusy	;nastav priznak cekani na Ready

	ret

;*****************************************************************************
;Povoli prikazy mazani a zapisu do EEPROM
EWEN:	call	StartSeq	;vysle startovaci sekvenci, select a start bit
	clr	SDI		;kod prikazu 0011
	call	ClockPulse
	call	ClockPulse
	setb	SDI
	mov	r0,#7
naen:	call	ClockPulse	;zde se vysle i dalsich 5 bitu s lib. hod.
	djnz	r0,naen
	clr	EESel
	clr	SDI
	call	ClockPulse
	ret

;*****************************************************************************
;Zakaze prikazy mazani a zapisu do EEPROM
EWDS:	call	CheckReady	;kontrola zda jiz byl dokoncen posledni zapis
				;zrusi EESel
	call	StartSeq	;start bit
	clr	SDI		;OPcode jsou prvni ctyri bity 0000
	mov	r0,#9
nads:	call	ClockPulse
	djnz	r0,nads
	clr	EESel		;ukonceni prikazu
	call	ClockPulse
	ret

;*****************************************************************************
;Provede inicializaci signalu pro komunikaci s  EEPROM
EEINI:	clr	EESel		;zrus vyber EEPROM
	clr	SClk		;Hodinovy vodic do log. 0
	clr	SDI		;nuluj vstup EEPROM
	setb	SDO		;bude se pouzivat jako vstupni vodic
	clr	WaitingBusy	;vymazani priznaku nedokonceneho zapisu
    ret


; ---------------------------------------------------------------------
; INTERNI FUNKCE,  pro generovani signalu pro EEPROM
;  jsou volany z funkci READBYTE,WRITEBYTE, EWEN,EWDIS

;*****************************************************************************
;Pamet EEPROM vysouva data se sestupnou hranou, platna jsou na nabeznou
;Generuje pocatecni sekvenci prikazu
StartSeq: 
        clr     SDI             ;nuluj datovy bit
        setb    EESel           ;vyber pameti
        call    ClockPulse      
        setb    SDI             ;start bit
        
ClockPulse: 
        setb    SClk            ;hodinovy impulz
        nop
        clr     SClk
        nop
        ret

;*****************************************************************************
;Vysle adresu do pameti, vysila se od MSB. Provadi inkrementaci adresy
GenAdr:
        mov     a,Address       ;vezmu adresu
        inc     Address         ;inkrementuj adresu
        rl      a               ;jednou narotuji, bit a7 se nepouziva
        mov     r0,#7           ;pocet vysilanych bitu do r0

gaadr:  
        rlc     a               ;nejvyssi bit do Carry
        mov     SDI,C           ;Carry zkopiruj na SDI
        call    ClockPulse      ;generuj hodinovy pulz
        djnz    r0,gaadr
        ret

;*****************************************************************************
;Testuje, zda nebyl zapis a pokud ano, zda je jiz dokoncen
CheckReady: 
        jnb WaitingBusy,NoWrite ;pokud nenastaven, nebyl zapis

naPulse: 
        call    ClockPulse
        jnb     SDO,naPulse             ;dokud EEPROM busy, cekej
        clr     WaitingBusy     ;shod priznak cekani na dokonceni zapisu
        clr     EESel           ;shod select pameti do 0
        call    ClockPulse
NoWrite: 
        ret

;*******************SUBRUTINA OBSAZENI DISPLEJE*****************
;V Acc je cislo funkce pozadovane k zobrazeni na momentalne aktivni displej
;vraci v dis_ho a dis_lo BCD cislo. Nastavuje parametry desetinne tecky
;**************************************************************** 

obsazeni_disp:CJNE A,#fce_hodiny,pokr_01	;je pozadavek hodin
		MOV dis_hi,hodiny		;provedeno nacteni hodin a minut
		MOV dis_lo,minuty
		MOV A,displej		;nacti o jaky se displej se jedna
		CJNE A,#typ_fce_dis0,pokr_28	;prvni displej, pricti hodnotu pro zvyseni prvnich hodin
		MOV vstup,incr_hod0	;nacti posuv o x hod
		LCALL hex2bcd		;prevede na BCD
		MOV A,dis_hi		;nacti cislo pro treti displej
		ADD A,vysl			;pricti vysledek prevodu
		DA A
		SJMP kontrola_preteceni

pokr_28:	CJNE A,#typ_fce_dis1,pokr_29
		MOV vstup,incr_hod1	;nacti posuv o x hod
		LCALL hex2bcd		;prevede na BCD
		MOV A,dis_hi		;nacti cislo pro treti displej
		ADD A,vysl			;pricti vysledek prevodu
		DA A
		SJMP kontrola_preteceni

pokr_29:	CJNE A,#typ_fce_dis2,pokr_31
		MOV vstup,incr_hod2	;nacti posuv o x hod
		LCALL hex2bcd		;prevede na BCD
		MOV A,dis_hi		;nacti cislo pro treti displej
		ADD A,vysl			;pricti vysledek prevodu
		DA A
		SJMP kontrola_preteceni	

pokr_31:	MOV vstup,incr_hod3	;nacti posuv o x hod
		LCALL hex2bcd		;prevede na BCD
		MOV A,dis_hi		;nacti cislo pro treti displej
		ADD A,vysl			;pricti vysledek prevodu
		DA A

;-----------------Porovna fce_hodiny a pokud jsou vice nez 24, odecte 24 BCD----------
kontrola_preteceni:
		CJNE A,#24H,pokr_54	;porovnej Acc a nastav CY  pokud A >= data pak CY = 0
pokr_54:	JC navrat_08		;pokud A < data CY=1
		CJNE A,#49H,pokr_61	
pokr_61:	JNC podteceni
		ADD A,#76H			;Acc = nebo > 24, uprav vysledek prictenim dekadickeho doplnku 24 (t.zn.odecti 24)
		DA A
navrat_08:	MOV dis_hi,A
		RET
						;pokud se pri snizovani DOWN dostanu pod nulu, pak nedojde k preteceni k pricteni
						;komplementu a je treba upravit vysledek 
podteceni:	ADD A,#24H			;je to vice nez 24+24 hodin,jde o podteceni zeshora pri dekrementaci
		DA A				
		SJMP navrat_08
;---------------------------------------------------------------------------------	


pokr_01:	CJNE A,#fce_datum,pokr_02	;je pozadavek na zobrazovani data
		MOV dis_hi,den		;nacti data	
		MOV dis_lo,mesic		;nacti data
		SETB tecka			;nastav priznak tecky
		SJMP navrat_01

pokr_02:	CJNE A,#fce_rok,pokr_03	;pozadavek na zobrazovani roku
		MOV dis_hi,#20H
		MOV dis_lo,rok
		SJMP navrat_01

pokr_03:	MOV dis_hi,#0BBH	;pozadavek na zobrazovani dne v tydnu / prvni 2 cisla zhasni
		MOV dis_lo,d_v_t

navrat_01:		RET

;-----------------------PREVOD HEXA na BCD------------------------
hex2bcd:	MOV vaha,#1H
		MOV vysl,#0H
		MOV pocpos,#8H
znovu:	CLR C
		MOV A,vstup
		RRC A	
		MOV vstup,A
		JNC increment_vahu
		MOV A,vysl
		ADD A,vaha
		DA A
		MOV vysl,A
increment_vahu:MOV A,vaha
		ADD A,ACC
		DA A
		MOV vaha,A
		DJNZ pocpos,znovu
		RET
;--------------------------------------------------------------------

;*******************SUBRUTINA VYMASKOVANI DISPLEJE NA ZOBRAZENI 1 CIFRY***************** 
 
;***********************PRVNI ANODA**************
maskuj: 	MOV DPTR,#tabznak	;nacti prvni adresu tabulky znaku
		MOV A,anoda		;nacti anodu
		JNZ pokr_04		;prvni anoda je 0, ponech vyssi nibble z vyssiho byte displeje
		MOV A,@R0		;cti pozadovanou fci k zobrazeni		
		CJNE A,#fce_hodiny,pokr_22
		MOV A,dis_hi
		ANL A,#0F0H
		SWAP A
		MOVC A,@A+DPTR		;cti reprezentaci cisla v tabulce
		SJMP navrat_02
		
pokr_22:	MOV A,dis_hi	;pro nezobrazeni bezvyznamnych nul krome hodin
		ANL A,#0F0H
		JZ pokr_23		;je prvni cislo nula?
		SWAP A
		MOVC A,@A+DPTR		;cti reprezentaci cisla v tabulce
		SJMP navrat_02

pokr_23:	MOV A,#0H
		SJMP navrat_02


;***********************DRUHA ANODA**************
pokr_04:	CJNE A,#1,pokr_05
		MOV A,dis_hi
		ANL A,#0FH
		MOVC A,@A+DPTR		;cti reprezentaci cisla v tabulce
		MOV R2,A			;schovej hodnotu
		MOV A,@R0			;cti pozadovanou k zobrazeni
		JNZ pokr_07			;jsou to fce_hodiny?
		JB FULL_SECOND,navrat_03 ;jsou to fce_hodiny,tecka neni,ven
		MOV A,R2			;obnov data
		ADD A,#128			;pricti tecku
		SJMP navrat_02		;ven (posli na port)
pokr_07:	CJNE A,#fce_datum,navrat_03	;jde o fce_datum?
		MOV A,R2			;obnov data
		ADD A,#128			;rozsvit tecku trvale
		SJMP navrat_02

;***********************TRETI ANODA**************
pokr_05:	CJNE A,#2,pokr_06
		MOV A,@R0			;cti pozadovanou fci k zobrazeni
		CJNE A,#fce_DvT,pokr_20	;je to den v tydnu?
		MOV DPTR,#dvt_tab		;ano nacti jimou tabulku
		MOV A,dis_lo		;cti hodnotu
		RL A				;nasob x2 (dny jsou po dvou pismenech	
		SUBB A,#1H			;odecti 1 pro prechod na prvni pismeno	
		MOVC A,@A+DPTR		;nacti reprezentaci
		MOV DPTR,#tabznak		;vrat DPTR na cisla
		SJMP navrat_02

pokr_20:	MOV DPTR,#tabznak
		MOV A,dis_lo
		ANL A,#0F0H
		JNZ pokr_26			;je to nula?
		MOV R2,A			;je to nula,uloz a testuj zda jde o fce_datum
		MOV A,@R0			;cti fci
		CJNE A,#fce_datum,pokr_25	;pokud nejde o fce_datum,cti zpet hodnotu a vrat se beze zmeny
		MOV A,#0B0H			;zadej prazdny znak - bacha u pokr_26 se provede swap proto neni 0B ale 0B0!!!
		SJMP pokr_26
pokr_25:	MOV A,R2 
pokr_26:	SWAP A
		MOVC A,@A+DPTR		;cti reprezentaci cisla v tabulce
		SJMP navrat_02
	
;***********************CTVRTA ANODA**************
pokr_06:	MOV A,@R0			;cti pozadovanou fci k zobrazeni
		CJNE A,#fce_DvT,pokr_21	;je to den?
		MOV DPTR,#dvt_tab		;ano nacti jimou tabulku
		MOV A,dis_lo		;cti hodnotu
		RL A				;nasob x2 (dny jsou po dvou pismenech
		MOVC A,@A+DPTR		;nacti reprezentaci
		SJMP navrat_02

pokr_21:	MOV A,dis_lo
		ANL A,#0FH
		MOVC A,@A+DPTR		;cti reprezentaci cisla v tabulce
		MOV R2,A			;schovej hodnotu
		MOV A,@R0			;cti pozadovanou k zobrazeni
		CJNE A,#fce_datum,navrat_03	;jde o fce_datum?
		MOV A,R2			;ano,obnov data
		ADD A,#128
		SJMP navrat_02

navrat_03:	MOV A,R2			;obnov data pro katody
navrat_02:	JNB po_resetu,platna_data	;po resetu kdy jeste nejsou k dispozici platna data zobrazuj pomlcky a blikej teckou
		MOV A,#64				;rozsvit pomlcku
		JB FULL_SECOND,platna_data	;testuj blikani tecky
		MOV A,#0				;a blikej pomlckama
platna_data:CPL A				;proved negaci pro spolecnou anodu
		MOV tmp,A
		RET

;nezapomen do preruseni od DCF zadat zpet adresu do DPTR na tabulku znaku/schovat DPH a DPL 
;--------------------------PRVNI DISPLEJ--------------------------------------------------------

anody:	MOV A,displej
		CJNE A,#typ_fce_dis0,pokr_08	;prvni displej,neni jdi na druhy
		MOV A,anoda
		JNZ pokr_10
		JNB edit0,pokr_40
		JB FULL_SECOND,pokr_40
		MOV tmp,#0FFH		;zhasni displej / blikani v editu
pokr_40:	LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR 	anoda_0_dis_0	;sepni anodu
		SJMP navrat_05
	
pokr_10:	CJNE A,#1,pokr_11
		JNB edit0,pokr_41
		JB FULL_SECOND,pokr_41
		MOV tmp,#0FFH		;zhasni displej / blikani v editu
pokr_41:	LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_1_dis_0
		SJMP navrat_05

pokr_11:	CJNE A,#2,pokr_12
		LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_2_dis_0
		SJMP navrat_05


pokr_12:	;posledni anoda se netestuje
		LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_3_dis_0
		JB vst_TL,pokr_35 		;je stisknuto tlacitko u tretiho displeje?
		SETB stisknuto0			;tlacitko stisknuto, nastav priznak 
		JB edit0,navrat_05
		DJNZ doba_tlacitka0,navrat_05
		MOV A,@R0				;cti funkci
		CJNE A,#fce_hodiny,navrat_05	;pokud to nejsou fce_hodiny, nevstupuj do editace
		SETB edit0				;editace
		SJMP navrat_05

pokr_35:	JNB stisknuto0,navrat_05			;tlacitko uvolneno
		CLR stisknuto0
		JNB edit0,pokr_42		;jsem v editaci,testuj cas
		MOV A,doba_tlacitka0	;cas je nulovy, edit byl nastaven v minulem obehu bez uvolneni tlacitka
		JNZ konec_editu0		;a tak nic nedelej
		MOV doba_tlacitka0,#50H		;nacti dobu nutnou pro vstup do editace
		SJMP navrat_05		;tlacitko bylo stisknuto znova a uvolneno,vystup z editace

pokr_42:	MOV doba_tlacitka0,#50H		;nacti dobu nutnou pro vstup do editace
		INC typ_fce_dis0			;zvys pozadovanou fci
		MOV A,typ_fce_dis0		;test,zda je posledni
		XRL A,#04H				
		JNZ navrat_05		
		MOV typ_fce_dis0,A
navrat_05:	RET

konec_editu0:CLR edit0
		LCALL zapis			;volej ulozeni do eeprom, uloz i obsazeni displeju
		SJMP navrat_05

;----------------------DRUHY DISPLEJ----------------------------------------
pokr_08:	CJNE A,#typ_fce_dis1,pokr_63
		MOV A,anoda
		JNZ pokr_13
		JNB edit1,pokr_43
		JB FULL_SECOND,pokr_43
		MOV tmp,#0FFH		;zhasni displej / blikani v editu
pokr_43:	LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR 	anoda_0_dis_1	;sepni anodu
		SJMP navrat_05


pokr_63:	AJMP pokr_09
	
pokr_13:	CJNE A,#1,pokr_14
		JNB edit1,pokr_44
		JB FULL_SECOND,pokr_44
		MOV tmp,#0FFH		;zhasni displej / blikani v editu
pokr_44:	LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_1_dis_1
		SJMP navrat_05

pokr_14:	CJNE A,#2,pokr_15
		LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_2_dis_1
		SJMP navrat_10


pokr_15:	;posledni anoda se netestuje
		LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_3_dis_1
		JB vst_TL,pokr_36 		;je stisknuto tlacitko u tretiho displeje?
		SETB stisknuto1			;tlacitko stisknuto, nastav priznak 
		JB edit1,navrat_10
		DJNZ doba_tlacitka1,navrat_10
		MOV A,@R0				;cti funkci
		CJNE A,#fce_hodiny,navrat_10	;pokud to nejsou fce_hodiny, nevstupuj do editace
		SETB edit1				;editace
		SJMP navrat_10
	
pokr_36:	JNB stisknuto1,navrat_10			;tlacitko uvolneno
		CLR stisknuto1
		JNB edit1,pokr_45		;jsem v editaci,testuj cas
		MOV A,doba_tlacitka1	;cas je nulovy, edit byl nastaven v minulem obehu bez uvolneni tlacitka
		JNZ konec_editu1		;a tak nic nedelej
		MOV doba_tlacitka1,#50H		;nacti dobu nutnou pro vstup do editace
		SJMP navrat_10		;tlacitko bylo stisknuto znova a uvolneno,vystup z editace

pokr_45:	MOV doba_tlacitka1,#50H		;nacti dobu nutnou pro vstup do editace
		INC typ_fce_dis1			;zvys pozadovanou fci
		MOV A,typ_fce_dis1		;test,zda je posledni
		XRL A,#04H				
		JNZ navrat_10		
		MOV typ_fce_dis1,A
navrat_10:	RET	
			
konec_editu1:CLR edit1
		LCALL zapis			;volej ulozeni do eeprom, uloz i obsazeni displeju
		RET

;----------------------TRETI DISPLEJ----------------------------------------
pokr_09:	CJNE A,#typ_fce_dis2,pokr_30
		MOV A,anoda
		JNZ pokr_16
		JNB edit2,pokr_38
		JB FULL_SECOND,pokr_38
		MOV tmp,#0FFH		;zhasni displej / blikani v editu
pokr_38:	LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR 	anoda_0_dis_2	;sepni anodu
		SJMP navrat_10
	
pokr_16:	CJNE A,#1,pokr_17
		JNB edit2,pokr_39		;jsem v editaci?
		JB FULL_SECOND,pokr_39	;a je blik tecka?
		MOV tmp,#0FFH		;zhasni displej / blikani v editu	;pak cislo nezobrazuj
pokr_39:	LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_1_dis_2		;jinak ano
		SJMP navrat_10

pokr_17:	CJNE A,#2,pokr_18		;u tato anody se testuje pozadavek down
		LCALL zhasni		
		MOV P1,tmp			;vyber data katod
		CLR anoda_2_dis_2
		JB vst_TL,pokr_55
		SETB stisknuto_DOWN
		SJMP navrat_10

pokr_55:	JNB stisknuto_DOWN,navrat_10
		CLR stisknuto_DOWN			;nuluj priznak
		JNB edit0,pokr_56			;editovan prvni displej
		MOV A,incr_hod0			;nacti data
		LCALL porovnej_1
		MOV incr_hod0,A			;uloz zpet
		SJMP navrat_09

pokr_56:	JNB edit1,pokr_57			;editovan druhy displej
		MOV A,incr_hod1
		LCALL porovnej_1
		MOV incr_hod1,A			;uloz zpet
		SJMP navrat_09

pokr_57:	JNB edit2,pokr_58			;editovan treti displej
		MOV A,incr_hod2
		LCALL porovnej_1
		MOV incr_hod2,A			;uloz zpet
		SJMP navrat_09

pokr_58:	JNB edit3,navrat_09		;nejsi v editaci tak se vrat
		MOV A,incr_hod3
		LCALL porovnej_1
		MOV incr_hod3,A			;uloz zpet
		SJMP navrat_09

pokr_30:	AJMP pokr_60

;-------------------------------------------------------------------
;snizi cislo pozadovaneho offsetu cifry o jednu a testuje dosazeni meze
porovnej_1:	DEC A					;sniz o jednu
		CJNE A,#04BH,pokr_59 		;testuj dosazeni meze / pozor je to komplement cisla
		INC A					;vrat zpet hodnotu
		RET					;a vrat se
pokr_59:	CJNE A,#0FFH,navrat_09		;po dosazeni podteceni pod nulu se nacte hexadecimalni komplement (99D),ktery po pricteni da 
		MOV A,#063H				;cislo o jednu mensi. Preteceni se neuvazuje.Ten se snizuje kazdou dekrementaci. Pokud u vysledku
							;pak nedojde k preteceni (napr. snizeni 10 hodin o 11, t.j. 89H +10H=99H) testuje se CY
							;v rutine porovnej. Dalsi popis je tam		
		RET
;---------------------------------------------------------------------------------------

pokr_18:	;posledni anoda se netestuje
		LCALL zhasni
		MOV P1,tmp				;vyber data katod
		CLR anoda_3_dis_2			;rozsit anodu	
		JB vst_TL,pokr_27 		;je stisknuto tlacitko u tretiho displeje?
		SETB stisknuto2			;tlacitko stisknuto, nastav priznak 
		JB edit2,navrat_09
		DJNZ doba_tlacitka2,navrat_09
		MOV A,@R0				;cti funkci
		CJNE A,#fce_hodiny,navrat_09	;pokud to nejsou fce_hodiny, nevstupuj do editace
		SETB edit2				;editace
		SJMP navrat_09
	
pokr_27:	JNB stisknuto2,navrat_09			;tlacitko uvolneno
		CLR stisknuto2
		JNB edit2,pokr_37		;jsem v editaci,testuj cas
		MOV A,doba_tlacitka2	;cas je nulovy, edit byl nastaven v minulem obehu bez uvolneni tlacitka
		JNZ konec_editu2		;a tak nic nedelej
		MOV doba_tlacitka2,#50H		;nacti dobu nutnou pro vstup do editace
		SJMP navrat_09		;tlacitko bylo stisknuto znova a uvolneno,vystup z editace
		
pokr_37:	MOV doba_tlacitka2,#50H		;nacti dobu nutnou pro vstup do editace
		INC typ_fce_dis2			;zvys pozadovanou fci
		MOV A,typ_fce_dis2		;test,zda je posledni
		XRL A,#04H				
		JNZ navrat_09		
		MOV typ_fce_dis2,A
				
navrat_06:RET
konec_editu2:CLR edit2
		LCALL zapis			;volej ulozeni do eeprom, uloz i obsazeni displeju
navrat_09:	RET

;--------------------Ctvrty displej---------------------
pokr_60:	MOV A,anoda
		JNZ pokr_32
		JNB edit3,pokr_46
		JB FULL_SECOND,pokr_46
		MOV tmp,#0FFH		;zhasni displej / blikani v editu
pokr_46:	LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR 	anoda_0_dis_3	;sepni anodu
		SJMP navrat_07
	
pokr_32:	CJNE A,#1,pokr_33
		JNB edit3,pokr_47
		JB FULL_SECOND,pokr_47
		MOV tmp,#0FFH		;zhasni displej / blikani v editu
pokr_47:	LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_1_dis_3
		SJMP navrat_07

pokr_33:	CJNE A,#2,pokr_34 		;u tato anody se testuje pozadavek UP
		LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_2_dis_3
		JB vst_TL,pokr_50
		SETB stisknuto_UP
		SJMP navrat_07

pokr_50:	JNB stisknuto_UP,navrat_04
		CLR stisknuto_UP			;nuluj priznak
		JNB edit0,pokr_51			;editovan prvni displej
		MOV A,incr_hod0
		INC A
		LCALL porovnej
		MOV incr_hod0,A
		SJMP navrat_07

pokr_51:	JNB edit1,pokr_52			;editovan druhy displej
		MOV A,incr_hod1
		INC A
		LCALL porovnej
		MOV incr_hod1,A
		SJMP navrat_07

pokr_52:	JNB edit2,pokr_53			;editovan treti displej
		MOV A,incr_hod2
		INC A
		LCALL porovnej
		MOV incr_hod2,A
		SJMP navrat_07

pokr_53:	JNB edit3,navrat_04		;neni zadna editace,navrat
		MOV A,incr_hod3
		INC A
		LCALL porovnej
		MOV incr_hod3,A
		SJMP navrat_07
;---------------------------------------------------------
porovnej:	CJNE A,#64H,pokr_62		;vrat zpet hodnotu po prechodu z odecitani (po podteceni nuly pri odecitani
		CLR A					;se nacte doplnek 99dec t.j. 63H. Kdyz se pak promenna inkrementuje
							;musi dojit k preteceni zase po 64H na 0,jinak by se pricitalo dal 
pokr_62:CJNE A,#18H,navrat_07	;pokud je pricteni hodin vice nez 24, dal uz nepricitej / mez,kolik jde max. pricist
		DEC A
navrat_07:	RET
;----------------------------------------------------------

pokr_34:	;posledni anoda se netestuje
		LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_3_dis_3
		JB vst_TL,pokr_48			;je stisknuto tlacitko u tretiho displeje?
		SETB stisknuto3			;tlacitko stisknuto, nastav priznak 
		JB edit3,navrat_07
		DJNZ doba_tlacitka3,navrat_07
		MOV A,@R0				;cti funkci
		CJNE A,#fce_hodiny,navrat_07	;pokud to nejsou fce_hodiny, nevstupuj do editace
		SETB edit3				;editace
		SJMP navrat_07
	
pokr_48:	JNB stisknuto3,navrat_07			;tlacitko uvolneno
		CLR stisknuto3
		JNB edit3,pokr_49		;jsem v editaci,testuj cas
		MOV A,doba_tlacitka3	;cas je nulovy, edit byl nastaven v minulem obehu bez uvolneni tlacitka
		JNZ konec_editu3		;a tak nic nedelej
		MOV doba_tlacitka3,#50H		;nacti dobu nutnou pro vstup do editace
		SJMP navrat_07		;tlacitko bylo stisknuto znova a uvolneno,vystup z editace
		
pokr_49:	MOV doba_tlacitka3,#50H		;nacti dobu nutnou pro vstup do editace
		INC typ_fce_dis3			;zvys pozadovanou fci
		MOV A,typ_fce_dis3		;test,zda je posledni
		XRL A,#04H				
		JNZ navrat_07		
		MOV typ_fce_dis3,A
				
navrat_04:RET

konec_editu3:CLR edit3
		LCALL zapis			;volej ulozeni do eeprom, uloz i obsazeni displeju
		SJMP navrat_07
;----------------------------------------------------------------------------------
;zhasne cislo/pro zjednoduseni se zhasinaji vsechny najednou (i "zhasnute")
zhasni:	SETB anoda_0_dis_0
		SETB anoda_1_dis_0
		SETB anoda_2_dis_0
		SETB anoda_3_dis_0

		SETB anoda_0_dis_1
		SETB anoda_1_dis_1
		SETB anoda_2_dis_1
		SETB anoda_3_dis_1

		SETB anoda_0_dis_2
		SETB anoda_1_dis_2
		SETB anoda_2_dis_2
		SETB anoda_3_dis_2

		SETB anoda_0_dis_3
		SETB anoda_1_dis_3
		SETB anoda_2_dis_3
		SETB anoda_3_dis_3

	RET		
;---------------------------------------------------------------------------
wait:		mov r3,#0A0H
wait_1:	MOV r4,#01H
		DJNZ R4,$
		DJNZ R3,wait_1
	RET
;------------------------vypise na displej postupne logo DAVI----------------------
logo:		MOV R2,#0FFH
		MOV R3,#0D0H
		MOV R4,#0C0H
		MOV R5,#0FFH
		LCALL pausa
logo_1:	MOV A,#94
		LCALL na_port
		CLR anoda_0_dis_3		;sviti D
		LCALL pausa
		SETB anoda_0_dis_3
		DJNZ R2,logo_1
		MOV R2,#1H
		MOV A,#119
		LCALL na_port
		CLR anoda_1_dis_3	
		LCALL pausa
		SETB anoda_1_dis_3
		DJNZ R3,logo_1
		MOV R2,#1H
		MOV R3,#1H
		MOV A,#28
		LCALL na_port
		CLR anoda_2_dis_3
		JB vst_TL,pokr_64
		SETB no_eeprom
pokr_64:	LCALL pausa
		SETB anoda_2_dis_3
		DJNZ R4,logo_1
		MOV R4,#01H
		MOV A,#6
		LCALL na_port
		CLR anoda_3_dis_3
		LCALL pausa
		SETB anoda_3_dis_3
		DJNZ R5,logo_1
		RET

na_port:	CPL A
		MOV P1,A
		RET
pausa:	mov r0,#0A0H
pausa_1:	MOV r1,#01H
		DJNZ R1,$
		DJNZ R0,pausa_1
	RET

;********preruseni od casovace************************

INTT0:  CLR RS0		;prvni registrova banka
	  mov     TL0,#T0valuL     ;nacti predvolbu
        mov     TH0,#T0valuH     ;nacti predvolbu
        PUSH    PSW
        PUSH    ACC
        PUSH    DPH
	  PUSH	DPL
	  djnz    tikker,read_dcf
        mov     tikker,#50		;software citac preruseni,po 20msec je incrementovan
        setb    full_second		;50x20 msec = 1 sec.
        call    increment
read_dcf:MOV A,tikker		;po 200 msec. nuluj priznak
	CJNE A,#5,dalsi
	CLR full_second
dalsi:call    scan_dcf77
exit_int:
	pop DPL
	pop DPH
        pop     acc
        pop     psw

	SETB RS0		;druha registrova banka
        reti
;****************************************************************************
;                S u b r u t i n a  D C F 7 7 _  I N I T                  *
; ---------------------------------------------------------------------------
; Inicializace pro cteni DCF-77
; Nastaveni casovace pro vyvolani INT po 20 msec.

DCF_INIT:
         mov     DCF_sekundy,#0     ;nuluj pocitadlo sekund (pulsu) od  DCF_sekundy

;---------------------------------->inicializace timeru
T0INIT:  MOV    TH0,#T0valuH        ;16 bit predvolba v modu 1
         MOV    TL0,#T0valuL
         MOV    TMOD,#11H           ;casovac 0 v modu 1
         SETB   TR0        		;start timer
         SETB   ET0              ;timer 0 INTERUPT ON
         SETB   EA              ;interupts on
;----------------------------------> set/clr  priznaky
         CLR     SYNCHRON           ;nesynchronizovano s DCF
         CLR     ok_data          ;priznak platnych dat v RAM z DCF pro moznost update
         CLR     PARITY_ERROR       ;Neplatna parita
         SETB    ASYNC              ;nesynchronizovano
         CLR     FULL_MINUTE        ;
         CLR     FULL_SECOND        ;
ret

;****************************************************************************
;         S u b r o u t i n e        S C A N _ D C F 7 7                    *
;****************************************************************************                                                                            |
; Rutina scanuje signal z DCF-77 a zapisuje datove bity postupn do bloku   *
; ("DATA_BLOCK").                                                           *
; --------------- !! Pozor DCF-77 signal je aktivni v nule (negovany) !!-   *
; Ve dvojite pause (59'sec) jsou hodiny synchronizovany s DCF77-signalem.   *
; Pokud jsou vsechna data spravne nactena v bloku, jdi na "UPDATE_TIME".    *
;Tam se zkontroluje parita a pokud je bez chyby nasleduje prepsani dat      *                                           
;----------------------------------------------------------------------------
SCAN_DCF77:
           MOV     C,dcf77_puls      ;prekopirovani urovne ze vstupu
           cpl     c                 ;negovani do spravne urovne
                                     ;na port jde aktivni puls 0, zde potrebujeme 1
           INC     COUNTER           ;citac delky impulsu
           JC      HIGH_NOW
           JNB     DCF_new,TO_THE_END    ;0 ---> 0 : trva uroven nula od minule - nic se nezmenilo,pausa trva
           SJMP    jedna_na_nula            ;1 ---> 0 : nastal prechod z 1 do 0, skok na obsluznou rutinu
HIGH_NOW:  JNB     DCF_new,nula_na_jedna ;0 ---> 1 : nastal prechod z 0 do 1, skok na obsluznou rutinu
TO_THE_END:LJMP    DCF77_RET                ;1 ---> 1 : trva uroven 1 od minule,nic se nezmenilo uroven trva(0 ---> 0)

nula_na_jedna:    ;<----Konec mezery,zacatek pulsu,nova sekunda: ( 0 ---> 1 )
          MOV     DCF_new,C        ;prekopirovani do priznaku, kterym se testuje, zda se nezmenil puls od minule
          MOV     A,COUNTER		;nacti delku pausy
          CLR     C
          SUBB    A,#PS_MIN           ;kontrola minimalni delky pausy
          JC      FAILURE             ;pausa nema minimalni delku - ven
	  SUBB    A,#PS_MAX-PS_MIN+1  ;test pausy pro pausu pro predchozi impuls "1"
          JC      SHORT_PAUSE         ;kratka pausa na data-impuls ( 0/1 )
          SUBB    A,#PL_MIN-PS_MAX-1  ;dvojita pausa na data-impuls ( 0/1 )
          JC      FAILURE
          SUBB    A,#PL_MAX-PL_MIN+1
          JC      LONG_PAUSE
          SUBB    A,#PSD_MIN-PL_MAX-1
          JC      FAILURE
          SUBB    A,#PSD_MAX-PSD_MIN+1
          JC      SHORT_DPAUSE
          SUBB    A,#PLD_MIN-PSD_MAX-1
          JC      FAILURE
          SUBB    A,#PLD_MAX-PLD_MIN+1
          JC      LONG_DPAUSE
          SJMP    FAILURE

LONG_PAUSE:
          SJMP    NEW_PULSE
SHORT_PAUSE:
          JNB     DATA_BIT,FAILURE    ;Signal-Pausa po "1"
          SJMP    NEW_PULSE

SHORT_DPAUSE:
        
          JB      ASYNC,INI_CYCLE     ;Pokud neni zasynchronizovano,inicializace
          JNB     DATA_BIT,FAILURE    ;dvojita pausa na hodnotu "1" na konci tlg.
          SJMP    CHECK_58
LONG_DPAUSE:
          JB      ASYNC,INI_CYCLE     ;Pokud neni zasynchronizovano,inicializace
          JB      DATA_BIT,FAILURE    ;dvojita pausa na hodnotu  "0" na konci tlg.
CHECK_58:
          mov     r1,DCF_sekundy
          CJNE    r1,#58,FAILURE      ;Jde o 58. Sekundu ??, ne chyba,ano pokracuj

	      CALL    UPDATE_TIME         ;<--- volani update dat, prepise aktualni data daty z DCF
          SETB    FULL_MINUTE         
          SETB    SYNCHRON		;nastav priznak synchronniho DCF a hodin
          SETB    ok_data           ;nastav priznak plneho bloku RAM, pokud je chyba v parite,stejne je nastaven                                 

 MOV     A,DATA_BLOCK+1
          MOV     C,ACC.5             ;= letni cas
          MOV     Z_cas, C           ;                                 
          MOV     C, ACC.3            ;= rezervni antena
          MOV     RES_ANT, C          ;

INI_CYCLE:MOV     DCF_sekundy,#-1     ;Pripraveno pro dalsi cyklus (minutu)
          CLR     ASYNC               ;nuluj priznak asynchronni

NEW_PULSE:INC     DCF_sekundy         ;novy platny impuls,zvys pocitadlo sekund od DCF
 
         SJMP    DCF77_END
;----------------------------------------------------------------------------
FAILURE:  CLR     SYNCHRON            ;vstupni impuls od DCF je mimo toleranci
          SETB    ASYNC		;nastav priznak asynchronni, nuluj synchronni
          SJMP    DCF77_END
;----------------------------------------------------------------------------

jedna_na_nula:    ;<-------Dekodovani impulsu podle delky:( 1 --> 0 )
          MOV     DCF_new,C        ;aktualizuj
          MOV     A,COUNTER
          CLR     C
          SUBB    A,#SS_MIN           ;Odecteni minimalniho trvani pulsu
          JC      FAILURE             ;pokud byl kratsi, neni platny 
          SUBB    A,#SS_MAX-SS_MIN+1  ;2 moznosti:
          JC      SHORT_PULSE         ;0.1 sec Impuls  =  "0"
          SUBB    A,#SL_MIN-SS_MAX-1  ;0.2 sec Impuls  =  "1"
          JC      FAILURE
          SUBB    A,#SL_MAX-SL_MIN+1
          JNC     FAILURE

LONG_PULSE:SETB   DATA_BIT            ;Hodnota bitu je '1'
          SJMP    BIT_KNOWN
SHORT_PULSE:CLR   DATA_BIT            ;Hodnota bitu je '0'

BIT_KNOWN:

          JB      ASYNC,DCF77_END     ;Neni synchro: VEN!
          mov     r1,DCF_sekundy
          CJNE    r1,#00,ADD?         ;Je ukoncen cyklus ??
          JB      DATA_BIT,FAILURE    ;Pokud neni ukoncen a data bit ma hodnotu 1 je to chyba
          SJMP    DCF77_END
ADD?:
          mov     r1,DCF_sekundy
          CJNE    r1,#04,ADD_IN?      
          MOV     block_ptr,#DATA_BLOCK
          mov     r0,block_ptr
          MOV     @r0,#80H            
          SJMP    SHIFT_IN
ADD_IN?:  JC      DCF77_END           
          mov     r1,DCF_sekundy
          CJNE    r1,#20,PAR?         
          JNB     DATA_BIT,FAILURE    
          SJMP    DCF77_END
PAR?:     mov     r1,DCF_sekundy
          CJNE    r1,#58,SHIFT_IN     
          SJMP    DCF77_END           
SHIFT_IN:
          MOV     C,DATA_BIT          
          mov     r0,block_ptr        
          XCH     A,@r0               
          RRC     A                   
          XCH     A,@r0
          JNC     DCF77_END          
	      MOV     A,#10000000B        ;mezni hodnota 8-bit hodnota
HR?:      mov     r1,DCF_sekundy
          CJNE    r1,#28,den?         
          RR      A                   ;mezni hodnota 7-bit hodnota
den?:     CJNE    r1,#35,NEXT_ENTRY
          RR      A
	    RR      A                   ;mezni hodnota 6-bit hodnota
NEXT_ENTRY:
          INC     block_ptr			;incrementuj ukazatel
          mov     r0,block_ptr		
          MOV     @r0,A              ;prepis udaj novou hodnotou

DCF77_END:MOV     COUNTER,#00        ;nuluj citac obehu
          

DCF77_RET:
          RET                        ;navrat
;****************************************************************************
;  S u b r o u t i n e        U P D A T E _ T I M E                         *
;****************************************************************************                                                                            
;  Rutina dekoduje "DATA_BLOCK" z casovych registru.
;  Vysledek je po kontrole parity zapsan do odpovidajicich byte.
; Pokud se vyskytne jedna chyba, nic neni prepsano a zustava puvodni udaj!!         
;----------------------------------------------------------------------------

UPDATE_TIME:      ;<---------------- nejprve kontroluje paritu

          MOV     R3,#05              ;casovy format= 5 Byte z "DATA_BLOCK"
          MOV     BLOCK_PTR,#DATA_BLOCK + 1
          MOV     B,#00               ;B: Parity-Bity 
GET_PAR:  INC     BLOCK_PTR
          mov     r0,block_ptr
          MOV     A,@r0
          MOV     C,PSW.0             
          XCH     A,B
          RLC     A
          XCH     A,B                 ;<---- porovnani
          DJNZ    R3,GET_PAR
          MOV     A,B
          MOV     C,DATA_BIT          
          RLC     A
          JNB     PSW.0,DATA_TO_REGS  ;Totale Parity je OK
          SETB    PARITY_ERROR        ;                            
          SJMP    UPDATE_END          ;Parity-chyba -> VEN!

DATA_TO_REGS:     ;<------------------;parita O.K. prepis data.

	CLR po_resetu			;nacteni o.k. nepreskakuj zobrazeni(pomlcky po resetu)
  	 MOV     A,DB_MIN            ;minutova-informace
          CLR     ACC.7               ;Paritni-Bit pryc
          MOV     minuty,A

          MOV     A,DB_HR             ;hodiny informace
	      RR      A                   ;7-data-bit hodnota
	      CLR     ACC.6               ;Paritni-Bit pryc
           MOV     hodiny,A

          MOV     A,DB_DAY            ;datum den-informace
          RR      A
	      RR      A                   ;6-data-bit hodnota
          MOV     den,A

          MOV     A,DB_MON            ;den v tydnu/mesic informace
          MOV     B,#00001000B        ;rozdel: den v tydnu = 3 Bit
          DIV     AB                  ;A= mesic    B=d_v_t
          MOV     d_v_t,B
          MOV     mesic,A

          MOV     A,DB_YR             ;rok-informace
          MOV     rok,A

          MOV     sekundy,#99H        ;<-- sekundy=0 na volle inleescyclus.
          MOV     tikker,#04          ;real time z DCF77-aktualizuj.
                                      ;Timer-citac = 40 msec.
          CLR     PARITY_ERROR        ;zadna chybna parita

UPDATE_END: RET

;****************************************************************************
;            S u b r u t i n a        I N C R E M E N T                   *   
;****************************************************************************
;   Rutina realneho casu sec:min:hr den/DvT:mesic:rok )
;   Kontroluje a spravne uklada pocet dni v mesici (30,31) a navic kontroluje
;   prestupny rok a upravuje unor. Bezi samostatne i bez synchro z DCF
;----------------------------------------------------------------------------

INCREMENT:
	MOV A,sekundy		;nacti do ACC byte vteriny
	ADD A,#1H			;pricti 1
	DA A				;korekce
	MOV sekundy,A		;uloz vteriny zpet
	XRL A,#60H			;je dosazeno minuty ?	
	JNZ INCR_END		;neni pak navrat z preruseni
	MOV sekundy,A		;nuluj byte vteriny
	SETB    FULL_MINUTE
	MOV A,minuty		;nacti do ACC obsah byte minuty
	ADD A,#1			;pricti k ACC 1
	DA A				;korekce
	MOV minuty,A		;uloz minuty zpet
	XRL A,#60H			;je dosazeno hodiny ?
	JNZ INCR_END			;neni pak navrat z preruseni pres test casu z tabulky
	MOV minuty,A		;nuluj byte minuty
	MOV A,hodiny		;nacti do ACC obsah byte hodiny
	ADD A,#1			;pricti k ACC 1
	DA A				;korekce
	MOV hodiny,A		;uloz zpet hodiny
	XRL A,#24H			;je dosazeno 24 hodin ?
	JNZ INCR_END			;neni pak navrat z preruseni pres test casu z tabulky
	MOV hodiny,A		;nuluj byte hodiny

          INC     d_v_t
          mov     r7,d_v_t
          CJNE    r7,#08,NEXT_DAY
	      MOV     d_v_t,#01         

NEXT_DAY: 
MOV A,den		;nacti do ACC obsah byte mesic
	ADD A,#1			;pricti k ACC 1
	DA A				;korekce
	MOV den,A		;uloz zpet mesic
      MOV     DPTR,#DAYS_PER_MONTH-1
      MOV     A,mesic             ;mesic(1...12)+TAB-1 = nastaveni
	MOVC    A,@A+DPTR           ;delka mesice / pocet dni
      MOV     r5,mesic
      CJNE    r5,#02,COMP_LEN
      MOV     B,A                 ;<-- mesic = unor
      MOV     A,rok		;cti rok
          
	;tady prevest rok z BCD na binarni
	LCALL BCD_2_HEX
	ANL     A,#00000011B			;zjisti zda je prestupny
      JNZ     NORMAL              ;pokud neni nula / neni prestupny
      MOV A,B		;je prestupny unor= 29 dni / zvys pocet dni z tabulky o jeden / pro unor 
	ADD A,#1
	DA A
	MOV B,A

NORMAL:   MOV     A,B                 ;neni prestupny, vrat pocet dni v mesici zpet
COMP_LEN: MOV     B,den			;cti aktualni den
          CJNE    A,B,INCR_END	;porovnej a pri preteceni nuluj
          MOV     den,#01H
        
	MOV A,mesic		;nacti do ACC obsah byte mesic
	ADD A,#1			;pricti k ACC 1
	DA A				;korekce
	MOV mesic,A		;uloz zpet mesic
	XRL A,#13H			;je dosazeno 12 mesicu ?
	JNZ INCR_END			;neni pak navrat 
	MOV mesic,#01H		;byte mesic / leden

	MOV A,rok		;nacti do ACC obsah byte roky
	ADD A,#1			;pricti k ACC 1
	DA A				;korekce
	MOV rok,A		;uloz zpet roky
	XRL A,#100H			;je dosazeno 100 let ?
	JNZ INCR_END			;neni pak navrat 
	MOV rok,A		;nuluj byte roky
INCR_END: RET
;--------------------------------------------------------------------------------
BCD_2_HEX:
		MOV R7,B			
		PUSH	ACC			
		ANL	A,#0f0h		
		SWAP	A			
		MOV	B,#10			
		MUL	AB			
		MOV	B,A			
		POP	ACC			
		ANL	A,#00fh		
		ADD	A,B			
		MOV B,R7			
		RET
;------------------------------------------------------------------------------

DAYS_PER_MONTH:                       ;Delka mesice - pocet dni,mesice jsou v BCD,ale vyhledavani v tabukce je hexa
          DB 32h                      ;cili mesic napr. 12BCD odpovida 18h a na te pozici je odpovidajici pocet dni
          DB 29h                       
          DB 32h
          DB 31h,32h,31h
          DB 32h,32h,31h,0,0,0,0,0,0,32h,31h,32h
         
;-------------Tabulky---------------
	version:	DB 0,28,64,134,79,0,0,0,0,0,0,0,0,0,0
;verse 1.0				^--toto cislo je souctem cifry a reprezentace desetinne tecky kvuli jejimu
;rozsviceni (aby se rozsvitila az s cislem a ne napred)

	tabznak:        DB 63,6,91,79,102,109,125,7,127,111,64,0
;reprezentace cisel       0,1,2 , 3, 4 , 5 , 6 ,7 ,8 , 9 , -,prazdny znak

dvt_tab:	DB 0,115,92,62,120,109,120,57,120,115,119,109,92,84,121,
;reprezentace dneP  o , U  t ,  S  t , C  t , P   A ,  S  o,n  E  , 

 END
